<?php
// +-------------------------------------------------------------------+
// | NinjaFirewall (Pro Edition)                                       |
// |                                                                   |
// | (c) NinTechNet - https://nintechnet.com/                          |
// |                                                                   |
// +-------------------------------------------------------------------+
// | This program is free software: you can redistribute it and/or     |
// | modify it under the terms of the GNU General Public License as    |
// | published by the Free Software Foundation, either version 3 of    |
// | the License, or (at your option) any later version.               |
// |                                                                   |
// | This program is distributed in the hope that it will be useful,   |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of    |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the     |
// | GNU General Public License for more details.                      |
// +-------------------------------------------------------------------+
$changelog = <<<'EOT'

= 4.2.8 =

* Pro+ Edition (Premium): Updated GeoIP databases.
* Updated security rules.
* Updated Charts.js library.
* Updated jQuery library.
* Small fixes and enhancements.

= 4.2.7 =

* Pro+ Edition (Premium): The Bot Access Control input accepts the following 6 additional characters: ( ) , ; ' ".
* Pro+ Edition (Premium): The URI Access Control can now apply to the REQUEST_URI environment variable. Previously, it applied only to SCRIPT_NAME.
* On newer PHP versions, NinjaFirewall will use the hrtime() function instead of microtime() for its metrics, because it is more reliable as it is not based on the internal system clock.
* Pro+ Edition (Premium): Updated GeoIP databases.
* Updated security rules.
* Updated Charts.js libraries.
* Small fixes and enhancements.

= 4.2.6 =

* The "Monthly Statistics" graph and tooltip colours were improved.
* Fixed several deprecated messages on sites running PHP 8.1+.
* Updated Charts.js libraries.
* Pro+ Edition (Premium): Updated GeoIP databases.
* Updated security rules.

= 4.2.5 =

* Updated security rules.
* Updated Charts.js to v3.6.1
* Pro+ Edition (Premium):  Updated Stripes webhook notifications IP addresses in the Access Control section.
* Pro+ Edition (Premium): Updated GeoIP databases.

= 4.2.4 =

* Updated security rules.
* Updated Charts.js to v3.6.1
* Pro+ Edition (Premium): Updated GeoIP databases.
* Small fixes and adjustments.

= 4.2.3 =

* Added a warning about the "X-XSS-Protection" HTTP header in the "Firewall Policies" section: although NinjaFirewall still supports it, it is now deprecated and only used by Safari. Consider using "Content-Security-Policy" (CSP) instead.
* Updated Charts.js to v3.4.1.
* Pro+ Edition (Premium): Updated IPv4/IPv6/ASN GeoIP databases.
* Updated security rules.
* Small fixes and enhancements.

= 4.2.2 =

* The "Uploads > Allow, but block dangerous files" policy will now block uploaded files that include JavaScript tags.
* Pro+ Edition (Premium): Added Paypal IPN new IP addresses to the Access Control whitelist.
* Fixed a potential false positive detection triggered when filtering base64-encoded payloads.
* Updated jQuery.
* Pro+ Edition (Premium): Updated IPv4/IPv6/ASN GeoIP databases.
* Updated security rules.

= 4.2.1 =

* Added a new firewall policy to block attempts to override PHP superglobals. See the "Firewall > Policies > Advanced Policies > Block attempts to override PHP Superglobals".
* Pro+ Edition (Premium): Updated IPv4/IPv6/ASN GeoIP databases.
* Updated security rules.

= 4.2 =

* Pro+ Edition (Premium): Added a new access control section: "User Input Access Control". It can be used to ignore or block specific user input (GET, POST and COOKIE). See "Firewall > Access Control > User Input".
* Pro+ Edition (Premium): We added a whitelist of IP addresses from the following payment gateways: Paypal and Stripes. If you use those services, you can easily whitelist them with the "Firewall > Access Control > IP Access Control > External Services" option.
* Fixed a bug that could reset some advanced policies when updating the firewall security rules.
* Fixed PHP 8.0 compatibility issues.
* Updated Chart.js to the latest version
* Pro+ Edition (Premium): Updated IPv4/IPv6/ASN GeoIP databases.
* Updated security rules.

= 4.1 =

* NinjaFirewall can now scan ZIP archives. If you have enabled the "Allow uploads, but block dangerous files" firewall policy, you can also enable the "Apply to ZIP archives file contents" option so that the firewall will extract and scan the files found in ZIP archives. See "Firewall > Policies > Basic Policies > Uploads > Apply to ZIP archives file contents".
* Pro+ Edition (Premium): Updated IPv4/IPv6/ASN GeoIP databases.
* Updated security rules.
* Small fixes and enhancements.

= 4.0.5 =

* Added a new policy to enable the "SameSite" flag on cookies in order to protect against cross-site request forgery (CSRF) attacks. See "Firewall > Policies > Advanced Policies > HTTP response headers > Force SameSite flag on all cookies".
* Added "preload" to the Strict-Transport-Security policy (HSTS) and the "max-age" value was increased up to 2 years (this is the recommended value for preload).
* Pro+ Edition (Premium): Updated IPv4/IPv6/ASN GeoIP databases.
* Updated security rules.
* Small fixes and enhancements.

= 4.0.4 =

* Fixed a potential issue where the installer didn't detect symlinks.
* Fixed a potential "Use of undefined constant NFW_IS_HTTPS" PHP warning when using the .htninja file.
* Pro+ Edition (Premium): Updated IPv4/IPv6/ASN GeoIP databases.
* Updated security rules.
* Small fixes and enhancements.

= 4.0.3 =

* Fixed all links (documentation and posts) pointing to our new website.
* Updated Chart.js to the latest version 2.9.3
* Updated security rules.
* Pro+ Edition (Premium): Updated IPv4/IPv6/ASN GeoIP databases.
* Small fixes and enhancements.

= 4.0.2 =

* Improved firewall engine:
    -Fixed a bug in the HTML entities decoder.
    -Added ES6 unicode detection and decoding.
* Pro+ Edition (Premium): Fixed a bug in the "Web Filter" where it could not be disabled if the textarea element was empty.
* Fixed a potential "Undefined index: size" PHP notice.
* Updated security rules.
* Pro+ Edition (Premium): Updated IPv4/IPv6/ASN GeoIP databases.

= 4.0.1 =

* Updated security rules.
* Pro+ Edition (Premium): Updated IPv4/IPv6/ASN GeoIP databases.

= 4.0 =

This is a major update.

* Improved NinjaFirewall overall interface and pages layout; added some simple toggle switches to replace radio buttons, better handling of error messages, cleaned up useless code etc.
* Most JavaScript code was rewritten from scratch, including all features that rely on it (e.g., "Live Log" etc).
* Pro+ Edition (Premium): The "Access Control" pages interface was simplified: it now uses simple textarea elements where you can copy/paste your data (URL, IP, Bot) very easily. The "Geolocation" page was simplified too.
* Pro+ Edition (Premium): In addition to an IP address or CIDR, you can now also enter an AS number (Autonomous System number) in the "IP Access Control". This new feature is very helpful if you want to allow or block all IPs from an ISP or hosting company: just enter their AS number instead of hundreds of IP addresses. Syntax is "AS" + the number, e.g. "AS12345". See "Access Control > IP Access Control".
* The admin interface will not use remote fonts from fonts.googleapis.com anymore, but your own ones instead. In addition, you can change the fonts family and size very easily from the "Account > Options > Appearance" menu, without having to upload your own CSS file.
* The maximum banning period for IP addresses has been increased from 999 to 9,999 minutes (Firewall > Options > Banned IP addresses).
* Pro+ Edition (Premium): The maximum banning period for rate-limiting has been increased from 999 to 9,999 seconds (Firewall > Access Control > IP Access Control > Rate limiting).
* The "Block the DOCUMENT_ROOT server variable in HTTP request" policy will not be enabled by default with new installations of NinjaFirewall.
* Fixed a bug in the firewall engine sanitizing function: when dealing with an empty string, the function was returning NULL rather than returning the empty value.
* Fixed a potential "Undefined index: size" PHP notice that could occur during uploads.
* Pro+ Edition (Premium): Fixed a bug where the ISO 3166 country code was not found when using an external PHP Variable instead of the built-in GeoIP database.
* Updated security rules.
* Many small fixes and enhancements.
* Pro+ Edition (Premium): Updated IPv4/IPv6/ASN GeoIP databases.

EOT;
// ---------------------------------------------------------------------
// EOF
